package com.lc.day21.lambda01;

import org.junit.Test;

import java.util.Arrays;
import java.util.Comparator;

/**
 * ClassName: Test01
 *
 * @Author 爱扣钉-陈晨
 * @Create 2024/1/19 9:32
 * @Version 1.0
 */
public class Test01 {

    @Test
    public void test01(){
        new Thread(new Runnable() {
            @Override
            public void run() {
                System.out.println("runnable");
            }
        }).start();

        // 更关注方法的实现逻辑。

        // 箭头函数  ->
        new Thread(() -> System.out.println("lambda")).start();

    }

    @Test
    public void test02(){
        String[] arr = {"hello","java","hi","python","c++"};

        //按照长度怕排序
        Arrays.sort(arr, (s1,s2) -> s1.length() - s2.length());

        //输出
        System.out.println(Arrays.toString(arr));

    }


    @Test
    public void test03(){
        String[] arr = {"hello","java","hi","python","c++"};

        //按照长度怕排序
//        Arrays.sort(arr, new Comparator<String>() {
//            @Override
//            public int compare(String o1, String o2) {
//                return o1.length() - o2.length();
//            }
//        });

        // lambda
        Arrays.sort(arr, (String o1, String o2)  ->  {return o1.length() - o2.length();} );

        //输出
        System.out.println(Arrays.toString(arr));
    }

    @Test
    public void test04(){
        /*
        - 当{Lambda体}中只有一句语句时，并且这个语句还是一个return语句，那么{、return、;}三者可以省略。
        - (形参列表)的数据类型可以省略。
        - 形参个数只有一个，()可以省略，形参名不能省略。
        - (形参列表)是空参时，()不能省略
         */

        String[] arr = {"hello","java","hi","python","c++"};
        // lambda
        Arrays.sort(arr, (String o1, String o2)  ->  {return o1.length() - o2.length();} );

        Arrays.sort(arr, (String o1, String o2)  ->   o1.length() - o2.length() );

        Arrays.sort(arr, (o1, o2)  ->   o1.length() - o2.length() );

        //输出
        System.out.println(Arrays.toString(arr));

        //一个参数
        Comparable<Integer> comparable =  o -> o * 2;
    }

}
